<?php

namespace Modules\Activity\Repositories\Contracts;

use Illuminate\Database\Eloquent\Collection;
use Modules\Activity\Entities\ActivityReport;

interface ActivityReportRepositoryInterface
{
    public function getAllPaginated(int $perPage = 10, string $search = '');

    public function getAllWithRelationsPaginated(
        int $perPage = 10,
        string $search = '',
        string $sortBy = 'created_at',
        string $sortOrder = 'desc'
    );

    public function getAllWithRelations(string $search = ''): Collection;

    public function create(array $data): ActivityReport;

    public function findById(string $id): ?ActivityReport;

    public function delete(string $id): bool;

    public function all(string $search = ''): Collection;
}
